import { ICollectionRef } from "./types";
declare type IWriteQueries = "set" | "update" | "delete" | "add";
declare type ICollectionQueries = "get" | "add" | "keys" | "delete-collection" | "list";
declare type IDocumentQueries = "get" | "set" | "update" | "delete";
declare type ICallQueryTypes = IWriteQueries | ICollectionQueries | IDocumentQueries | "snapshot" | "unsubscribe";
interface ITypedQuery<T> {
    path: string[];
    type: T;
    data?: any;
    options?: any;
}
declare const QueryRequest: unique symbol;
declare const Snapshots: unique symbol;
export default class Database {
    static WebSocket: typeof WebSocket;
    private initLock;
    private socket;
    private requests;
    constructor(url: string, database: string, accesskey?: string, authkey?: string, rootkey?: string);
    [Snapshots]: Map<string, (data: any) => void>;
    private handleSnapshot;
    private handleResponse;
    [QueryRequest]<T = any>(query?: ITypedQuery<ICallQueryTypes>, id?: string, ns?: string): Promise<T>;
    collection<T = any>(name: string): ICollectionRef<T>;
    collections(): Promise<ICollectionRef[]>;
    close(): void;
}
export {};
